## cbmc 5.4

=== src/Makefile ===
DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs \
       goto-symex langapi pointer-analysis solvers util linking xmllang \
       assembler analyses java_bytecode aa-path-symex path-symex musketeer \
       json cegis goto-analyzer

all: cbmc.dir goto-cc.dir goto-instrument.dir path-symex.dir goto-analyzer.dir

###############################################################################

util.dir: big-int.dir

# everything but big-int depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

.PHONY: languages
.PHONY: clean

cpp.dir: ansi-c.dir linking.dir

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir assembler.dir java_bytecode.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                     goto-symex.dir linking.dir analyses.dir solvers.dir \
                     json.dir

musketeer.dir: goto-instrument.dir

cbmc.dir: languages solvers.dir goto-symex.dir analyses.dir \
          pointer-analysis.dir goto-programs.dir linking.dir \
          goto-instrument.dir

goto-analyzer.dir: languages analyses.dir goto-programs.dir linking.dir \
                   json.dir goto-instrument.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir

# building for a particular directory

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files
	
generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

# minisat 2 download, for your convenience

minisat2-download:
	@echo "Downloading Minisat 2.2.1"
	@lwp-download http://ftp.debian.org/debian/pool/main/m/minisat2/minisat2_2.2.1.orig.tar.gz
	@tar xfz minisat2_2.2.1.orig.tar.gz
	@rm -Rf ../minisat-2.2.1
	@mv minisat2-2.2.1 ../minisat-2.2.1
	@(cd ../minisat-2.2.1; patch -p1 < ../scripts/minisat-2.2.1-patch)
	@rm minisat2_2.2.1.orig.tar.gz

glucose-download:
	@echo "Downloading glucose-syrup"
	@lwp-download http://www.labri.fr/perso/lsimon/downloads/softwares/glucose-syrup.tgz
	@tar xfz glucose-syrup.tgz
	@rm -Rf ../glucose-syrup
	@mv glucose-syrup ../
	@(cd ../glucose-syrup; patch -p1 < ../scripts/glucose-syrup-patch)
	@rm glucose-syrup.tgz

=== regression/taint/Makefile ===
default: tests.log

test:
	@../test.pl -c ../../../src/goto-analyser/goto-analyser

tests.log: ../test.pl
	@../test.pl -c ../../../src/goto-analyser/goto-analyser

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.java" "$$dir/*.out"; \
		fi; \
	done;

=== src/cbmc/Makefile ===
SRC = cbmc_main.cpp cbmc_parse_options.cpp bmc.cpp cbmc_dimacs.cpp \
      cbmc_languages.cpp counterexample_beautification.cpp \
      bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
      xml_interface.cpp cover.cpp all_properties.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/value_set$(OBJEXT) \
      ../pointer-analysis/value_set_analysis_fi$(OBJEXT) \
      ../pointer-analysis/value_set_domain_fi$(OBJEXT) \
      ../pointer-analysis/value_set_fi$(OBJEXT) \
      ../pointer-analysis/value_set_dereference$(OBJEXT) \
      ../pointer-analysis/dereference_callback$(OBJEXT) \
      ../pointer-analysis/add_failed_symbols$(OBJEXT) \
      ../pointer-analysis/rewrite_index$(OBJEXT) \
      ../pointer-analysis/goto_program_dereference$(OBJEXT) \
      ../goto-instrument/full_slicer$(OBJEXT) \
      ../goto-instrument/nondet_static$(OBJEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I ..

LIBS =

include ../config.inc
include ../common

CLEANFILES = cbmc$(EXEEXT)

all: cbmc$(EXEEXT)

ifneq ($(wildcard ../bv_refinement/Makefile),)
  OBJ += ../bv_refinement/bv_refinement$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_BV_REFINEMENT
endif

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java_bytecode/Makefile),)
  OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
  ifneq ($(LIBZIPLIB),)
    LIBS += -L $(LIBZIPLIB) -lzip -lz
  endif
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

cbmc$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: cbmc-mac-signed

cbmc-mac-signed: cbmc$(EXEEXT)
	strip cbmc$(EXEEXT) ; codesign -v -s $(OSX_IDENTITY) cbmc$(EXEEXT)

=== src/cegis/Makefile ===
SRC = danger/meta/meta_variable_names.cpp danger/facade/danger_runner.cpp danger/options/danger_program.cpp \
      danger/genetic/dynamic_danger_test_runner.cpp \
      danger/options/danger_program_printer.cpp danger/constraint/danger_constraint_factory.cpp \
      danger/preprocess/danger_preprocessing.cpp danger/preprocess/store_nondet_choices.cpp \
      danger/preprocess/add_ranking_and_skolem_variables.cpp danger/symex/learn/add_variable_refs.cpp \
      danger/symex/learn/add_programs_to_learn.cpp danger/symex/learn/solution_factory.cpp \
      danger/symex/learn/read_x0.cpp danger/symex/learn/add_x0_placeholders.cpp danger/symex/learn/danger_learn_config.cpp \
      danger/symex/learn/encoded_danger_learn_config.cpp danger/symex/verify/insert_candidate.cpp danger/symex/verify/restrict_counterexamples.cpp \
      danger/symex/verify/danger_verify_config.cpp danger/symex/verify/parallel_danger_verifier.cpp \
      danger/symex/verify/parallel_danger_verify_task.cpp danger/symex/fitness/danger_fitness_config.cpp \
      safety/options/safety_program.cpp safety/options/safety_program_printer.cpp safety/preprocessing/safety_preprocessing.cpp \
      safety/genetic/dynamic_safety_test_runner.cpp \
      safety/meta/meta_variable_names.cpp safety/constraint/safety_constraint_factory.cpp \
      safety/symex/learn/safety_learn_config.cpp safety/symex/learn/solution_factory.cpp \
      safety/symex/learn/add_variable_refs.cpp safety/symex/verify/safety_verify_config.cpp \
      safety/symex/learn/encoded_safety_learn_config.cpp safety/symex/learn/add_counterexamples.cpp \
      safety/symex/verify/insert_candidate.cpp safety/facade/safety_runner.cpp \
      safety/symex/fitness/safety_fitness_config.cpp safety/value/safety_goto_ce.cpp \
      safety/value/individual_to_safety_solution_deserialiser.cpp \
      invariant/options/invariant_program.cpp invariant/options/target_copy_helper.cpp \
      invariant/util/copy_instructions.cpp invariant/util/invariant_program_helper.cpp \
      invariant/util/invariant_constraint_variables.cpp invariant/instrument/meta_variables.cpp \
      invariant/constant/add_constant.cpp invariant/constant/default_constant_strategy.cpp \
      invariant/constant/literals_constant_strategy.cpp invariant/meta/meta_variable_names.cpp \
      invariant/preprocess/add_invariants_and_temp_variables.cpp invariant/preprocess/remove_loops_and_assertion.cpp \
      invariant/symex/learn/add_counterexamples.cpp invariant/symex/learn/add_invariant_programs_to_learn.cpp \
      invariant/symex/learn/instrument_vars.cpp invariant/symex/learn/invariant_library.cpp \
      invariant/symex/learn/replace_operators.cpp invariant/symex/verify/extract_counterexample.cpp \
      invariant/symex/verify/insert_constraint.cpp invariant/symex/verify/insert_program.cpp \
      invariant/fitness/concrete_fitness_source_provider.cpp \
      wordsize/restrict_bv_size.cpp value/program_individual_serialisation.cpp \
      seed/literals_seed.cpp genetic/tournament_select.cpp genetic/match_select.cpp \
      genetic/instruction_set_info_factory.cpp genetic/random_mutate.cpp genetic/random_cross.cpp \
      genetic/random_individual.cpp genetic/genetic_constant_strategy.cpp instructions/instruction_set_factory.cpp \
      genetic/concrete_test_runner.cpp genetic/dynamic_test_runner_helper.cpp genetic/genetic_settings.cpp \
      cegis-util/task_pool.cpp cegis-util/constant_width.cpp cegis-util/irep_pipe.cpp \
      runner/cegis_parse_options.cpp runner/cegis_main.cpp \
      ../goto-instrument/dump_c.cpp ../goto-instrument/goto_program2code.cpp \
      ../cbmc/cbmc_parse_options.cpp ../cbmc/bmc.cpp ../cbmc/cbmc_solvers.cpp ../cbmc/symex_bmc.cpp \
      ../cbmc/xml_interface.cpp ../cbmc/cover.cpp ../cbmc/bv_cbmc.cpp ../cbmc/counterexample_beautification.cpp \
      ../cbmc/cbmc_languages.cpp ../cbmc/show_vcc.cpp ../cbmc/cbmc_dimacs.cpp ../cbmc/all_properties.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../cpp/cpp$(LIBEXT) \
      ../java_bytecode/java_bytecode$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/value_set$(OBJEXT) \
      ../pointer-analysis/value_set_analysis_fi$(OBJEXT) \
      ../pointer-analysis/value_set_domain_fi$(OBJEXT) \
      ../pointer-analysis/value_set_fi$(OBJEXT) \
      ../pointer-analysis/value_set_dereference$(OBJEXT) \
      ../pointer-analysis/dereference_callback$(OBJEXT) \
      ../pointer-analysis/add_failed_symbols$(OBJEXT) \
      ../pointer-analysis/rewrite_index$(OBJEXT) \
      ../pointer-analysis/goto_program_dereference$(OBJEXT) \
      ../goto-instrument/full_slicer$(OBJEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I ..

LIBS = $(DLFCN_LINKFLAGS)

include ../config.inc
include ../common

CLEANFILES = cegis$(EXEEXT)

all: cegis$(EXEEXT)

###############################################################################

cegis$(EXEEXT): $(OBJ)
	$(LINKBIN)

=== src/cpp/Makefile ===
SRC = cpp_id.cpp cpp_language.cpp expr2cpp.cpp cpp_parser.cpp \
      cpp_typecheck.cpp cpp_convert_type.cpp \
      cpp_typecheck_expr.cpp cpp_typecheck_code.cpp \
      cpp_typecheck_type.cpp parse.cpp cpp_parse_tree.cpp \
      cpp_token_buffer.cpp cpp_typecheck_fargs.cpp \
      cpp_typecheck_resolve.cpp cpp_util.cpp cpp_enum_type.cpp \
      cpp_typecheck_function.cpp cpp_typecheck_namespace.cpp \
      cpp_name.cpp cpp_is_pod.cpp cpp_scope.cpp \
      template_map.cpp \
      cpp_scopes.cpp cpp_declarator.cpp cpp_instantiate_template.cpp \
      cpp_internal_additions.cpp cpp_type2name.cpp \
      cpp_typecheck_linkage_spec.cpp \
      cpp_typecheck_template.cpp cpp_typecheck_function_bodies.cpp \
      cpp_typecheck_initializer.cpp cpp_typecheck_compound_type.cpp \
      cpp_constructor.cpp cpp_destructor.cpp \
      cpp_typecheck_conversions.cpp\
      cpp_typecheck_declaration.cpp cpp_declarator_converter.cpp \
      cpp_declaration.cpp cpp_namespace_spec.cpp \
      cpp_typecheck_using.cpp cpp_exception_id.cpp \
      cpp_typecheck_enum_type.cpp cpp_typecheck_bases.cpp \
      cpp_typecheck_constructor.cpp \
      cpp_typecheck_destructor.cpp \
      cpp_typecheck_virtual_table.cpp \
      cpp_typecheck_static_assert.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = cpp$(LIBEXT)

all: cpp$(LIBEXT)

###############################################################################

cpp$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/goto-analyzer/Makefile ===
SRC = goto_analyzer_main.cpp goto_analyzer_parse_options.cpp \
      taint_parser.cpp taint_analysis.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../json/json$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I ..

LIBS =

include ../config.inc
include ../common

CLEANFILES = goto-analyzer$(EXEEXT)

all: goto-analyzer$(EXEEXT)

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java_bytecode/Makefile),)
  OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
  ifneq ($(LIBZIPLIB),)
    LIBS += -L $(LIBZIPLIB) -lzip -lz
  endif
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

goto-analyzer$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: goto-analyzer-mac-signed

goto-analyzer-mac-signed: goto-analyzer$(EXEEXT)
	strip goto-analyzer$(EXEEXT) ; codesign -v -s $(OSX_IDENTITY) goto-analyzer$(EXEEXT)

=== src/goto-instrument/Makefile ===
SRC = goto_instrument_parse_options.cpp rw_set.cpp \
      document_properties.cpp goto_instrument_languages.cpp \
      uninitialized.cpp full_slicer.cpp k_induction.cpp \
      object_id.cpp show_locations.cpp points_to.cpp \
      alignment_checks.cpp race_check.cpp \
      nondet_volatile.cpp interrupt.cpp function.cpp branch.cpp \
      mmio.cpp stack_depth.cpp nondet_static.cpp \
      concurrency.cpp dump_c.cpp dot.cpp havoc_loops.cpp \
      call_sequences.cpp unwind.cpp function_modifies.cpp \
      accelerate/accelerate.cpp accelerate/polynomial.cpp \
      accelerate/scratch_program.cpp accelerate/polynomial_accelerator.cpp \
      accelerate/util.cpp accelerate/trace_automaton.cpp \
      accelerate/enumerating_loop_acceleration.cpp \
      accelerate/all_paths_enumerator.cpp \
      accelerate/sat_path_enumerator.cpp \
      accelerate/disjunctive_polynomial_acceleration.cpp \
      accelerate/cone_of_influence.cpp accelerate/overflow_instrumenter.cpp\
      accelerate/path.cpp accelerate/acceleration_utils.cpp \
      count_eloc.cpp reachability_slicer.cpp goto_program2code.cpp \
      wmm/abstract_event.cpp wmm/fence.cpp wmm/shared_buffers.cpp \
      wmm/cycle_collection.cpp wmm/goto2graph.cpp wmm/weak_memory.cpp \
      wmm/data_dp.cpp wmm/instrumenter_strategies.cpp \
      wmm/event_graph.cpp wmm/pair_collection.cpp \
      goto_instrument_main.cpp horn_encoding.cpp \
      thread_instrumentation.cpp skip_loops.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../cpp/cpp$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/big-int$(LIBEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../assembler/assembler$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../analyses/analyses$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../util/util$(LIBEXT) \
      ../solvers/solvers$(LIBEXT)

INCLUDES= -I ..

LIBS = 

CLEANFILES = goto-instrument$(EXEEXT)

include ../config.inc
include ../common

all: goto-instrument$(EXEEXT)

ifneq ($(LIB_GLPK),)
  LIBS += $(LIB_GLPK)
  CP_CXXFLAGS += -DHAVE_GLPK
endif

###############################################################################

goto-instrument$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: goto-instrument-mac-signed

goto-instrument-mac-signed: goto-instrument$(EXEEXT)
	codesign -v -s $(OSX_IDENTITY) goto-instrument$(EXEEXT)

=== src/goto-programs/Makefile ===
SRC = goto_convert.cpp goto_convert_function_call.cpp \
      goto_convert_side_effect.cpp goto_program.cpp basic_blocks.cpp \
      goto_convert_exceptions.cpp property_checker.cpp \
      remove_function_pointers.cpp goto_functions.cpp goto_inline.cpp \
      remove_skip.cpp goto_convert_functions.cpp string_instrumentation.cpp \
      builtin_functions.cpp show_properties.cpp set_properties.cpp \
      read_goto_binary.cpp goto_asm.cpp elf_reader.cpp \
      string_abstraction.cpp destructor.cpp remove_asm.cpp \
      read_bin_goto_object.cpp goto_program_irep.cpp interpreter.cpp \
      interpreter_evaluate.cpp json_goto_trace.cpp \
      format_strings.cpp loop_ids.cpp pointer_arithmetic.cpp \
      goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
      remove_unused_functions.cpp remove_vector.cpp \
      wp.cpp goto_clean_expr.cpp safety_checker.cpp parameter_assignments.cpp \
      compute_called_functions.cpp link_to_library.cpp \
      remove_returns.cpp osx_fat_reader.cpp remove_complex.cpp \
      goto_trace.cpp xml_goto_trace.cpp vcd_goto_trace.cpp graphml_goto_trace.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = goto-programs$(LIBEXT)

all: goto-programs$(LIBEXT)

###############################################################################

goto-programs$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/java_bytecode/Makefile ===
SRC = java_bytecode_language.cpp java_bytecode_parse_tree.cpp \
      java_bytecode_typecheck.cpp expr2java.cpp \
      java_bytecode_convert.cpp java_types.cpp java_entry_point.cpp \
      java_bytecode_typecheck_code.cpp java_bytecode_typecheck_expr.cpp \
      java_bytecode_typecheck_type.cpp java_bytecode_internal_additions.cpp \
      java_bytecode_vtable.cpp java_bytecode_parser.cpp bytecode_info.cpp \
      java_class_loader.cpp jar_file.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = java_bytecode$(LIBEXT)

ifneq ($(LIBZIPINC),)
  INCLUDES += -I $(LIBZIPINC)/include -I /opt/local/include
  CP_CXXFLAGS += -DHAVE_LIBZIP
endif

all: java_bytecode$(LIBEXT)

###############################################################################

java_bytecode$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/util/Makefile ===
SRC = arith_tools.cpp base_type.cpp cmdline.cpp config.cpp symbol_table.cpp \
      expr.cpp expr_util.cpp i2string.cpp irep.cpp language.cpp \
      lispexpr.cpp lispirep.cpp source_location.cpp message.cpp language_file.cpp \
      mp_arith.cpp namespace.cpp parse_options.cpp rename.cpp \
      replace_expr.cpp threeval.cpp typecheck.cpp graph.cpp \
      type.cpp cnf_simplify.cpp pointer_predicates.cpp merge_irep.cpp \
      parser.cpp replace_symbol.cpp json.cpp \
      simplify_expr.cpp simplify_expr_floatbv.cpp simplify_expr_int.cpp \
      simplify_expr_array.cpp simplify_expr_struct.cpp \
      simplify_expr_boolean.cpp simplify_expr_pointer.cpp \
      get_module.cpp string_hash.cpp string_container.cpp identifier.cpp \
      rational.cpp options.cpp c_misc.cpp dstring.cpp \
      find_symbols.cpp rational_tools.cpp ui_message.cpp simplify_utils.cpp \
      time_stopping.cpp symbol.cpp irep_hash_container.cpp cout_message.cpp \
      type_eq.cpp guard.cpp array_name.cpp message_stream.cpp \
      substitute.cpp decision_procedure.cpp union_find.cpp \
      xml.cpp xml_irep.cpp xml_expr.cpp std_types.cpp std_code.cpp \
      format_constant.cpp find_macros.cpp ref_expr_set.cpp std_expr.cpp \
      irep_serialization.cpp fixedbv.cpp rename_symbol.cpp \
      ieee_float.cpp signal_catcher.cpp pointer_offset_size.cpp \
      bv_arithmetic.cpp tempdir.cpp tempfile.cpp timer.cpp unicode.cpp \
      irep_ids.cpp byte_operators.cpp string2int.cpp file_util.cpp \
      memory_info.cpp pipe_stream.cpp irep_hash.cpp endianness_map.cpp \
      vtable.cpp ssa_expr.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = util$(LIBEXT) \
             irep_ids.h irep_ids.inc \
             irep_ids_convert$(EXEEXT) irep_ids_convert$(OBJEXT) irep_ids_convert.d

all: util$(LIBEXT)

###############################################################################

irep_ids.h: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert$(EXEEXT) header < irep_ids.txt > $@

irep_ids.inc: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert$(EXEEXT) table < irep_ids.txt > $@

irep_ids.cpp: irep_ids.inc irep_ids.h

irep_ids_convert$(EXEEXT): irep_ids_convert.cpp
	$(LINKNATIVE)

generated_files: irep_ids.h irep_ids.inc

# Most of the others will need irep_ids.h,
# which we first need to generate.
$(OBJ): irep_ids.h

util$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== debian/changelog ===
cbmc (5.4-3) unstable; urgency=medium

  * Disable enum8 test due to limitations in C++ front-end. Thanks Lucas for
    reporting (Closes: #831166)

 -- Michael Tautschnig <mt@debian.org>  Thu, 14 Jul 2016 09:45:43 +0100

cbmc (5.4-2) unstable; urgency=low

  * Install goto-analyzer
  * Updated Standards version to 3.9.8 (no changes required)
  * Include recent big-endian patches to make mips(el), powerpc, s390x happy

 -- Michael Tautschnig <mt@debian.org>  Mon, 09 May 2016 09:07:09 +0100

cbmc (5.4-1) unstable; urgency=low

  * New upstream release
  * Builds using GCC 6 (Closes: #811603)
  * Changed watchfile to monitor github
  * Fully enable hardening
  * Updated Standards version to 3.9.7 (no changes required)

 -- Michael Tautschnig <mt@debian.org>  Fri, 22 Apr 2016 11:03:08 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-long-long -Wno-sign-compare -Wno-parentheses -Wno-strict-aliasing -pedantic

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C src clean
	$(RM) regression/*/tests.log
	$(RM) regression/*/*/*.out

override_dh_auto_build:
	$(MAKE) -C src \
		MINISAT2=/usr/include/minisat \
		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
		LIBZIPINC=/usr \
		LIBZIPLIB=/usr/lib

override_dh_auto_test:
	cd regression/ansi-c ; \
		if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cpp ; \
		if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cbmc ; \
		if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cbmc-concurrency ; \
		if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi

DEB_VERS=5.4
get-orig-source:
	svn export http://svn.cprover.org/svn/cbmc/releases/cbmc-$(DEB_VERS)
	tar cf cbmc_$(DEB_VERS).orig.tar cbmc-$(DEB_VERS)
	rm -rf cbmc-$(DEB_VERS)
	gzip -9n cbmc_$(DEB_VERS).orig.tar

## cbmc 5.5

=== regression/Makefile ===
DIRS = ansi-c cbmc cpp 

test:
	$(foreach var,$(DIRS), $(MAKE) -C $(var) test || exit 1;)

=== src/Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
 DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs \
        goto-symex langapi pointer-analysis solvers util linking xmllang \
        assembler analyses java_bytecode aa-path-symex path-symex musketeer \
-       json cegis goto-analyzer
+       json cegis goto-analyzer jsil symex goto-diff
 
-all: cbmc.dir goto-cc.dir goto-instrument.dir path-symex.dir goto-analyzer.dir
+all: cbmc.dir goto-cc.dir goto-instrument.dir symex.dir goto-analyzer.dir goto-diff.dir
 
 ###############################################################################
 
@@ -18,7 +18,8 @@
 cpp.dir: ansi-c.dir linking.dir
 
 languages: util.dir langapi.dir \
-           cpp.dir ansi-c.dir xmllang.dir assembler.dir java_bytecode.dir
+           cpp.dir ansi-c.dir xmllang.dir assembler.dir java_bytecode.dir \
+           jsil.dir
 
 goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                      goto-symex.dir linking.dir analyses.dir solvers.dir \
@@ -33,7 +34,14 @@
 goto-analyzer.dir: languages analyses.dir goto-programs.dir linking.dir \
                    json.dir goto-instrument.dir
 
+goto-diff.dir: languages goto-programs.dir pointer-analysis.dir \
+               linking.dir analyses.dir solvers.dir json.dir
+
 goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir
+
+symex.dir: languages goto-programs.dir pointer-analysis.dir \
+           goto-symex.dir linking.dir analyses.dir solvers.dir \
+           path-symex.dir goto-instrument.dir
 
 # building for a particular directory
 
@@ -75,3 +83,26 @@
 	@(cd ../glucose-syrup; patch -p1 < ../scripts/glucose-syrup-patch)
 	@rm glucose-syrup.tgz
 
+zlib-download:
+	@echo "Downloading zlib 1.2.8"
+	@lwp-download http://zlib.net/zlib-1.2.8.tar.gz
+	@tar xfz zlib-1.2.8.tar.gz
+	@rm -Rf ../zlib
+	@mv zlib-1.2.8 ../zlib
+	@rm zlib-1.2.8.tar.gz
+
+libzip-download:
+	@echo "Downloading libzip 1.1.2"
+	@lwp-download http://www.nih.at/libzip/libzip-1.1.2.tar.gz
+	@tar xfz libzip-1.1.2.tar.gz
+	@rm -Rf ../libzip
+	@mv libzip-1.1.2 ../libzip
+	@rm libzip-1.1.2.tar.gz
+
+libzip-build:
+	@echo "Building zlib"
+	@(cd ../zlib; ./configure; make)
+	@echo "Building libzip"
+	@(cd ../libzip; BASE=`pwd`; ./configure --with-zlib=$(BASE)/zlib ; make)
+
+.PHONY: minisat2-download glucose-download zlib-download libzip-download libzip-build

=== regression/goto-instrument-unwind/Makefile ===
default: tests.log

testalpha:
	@../test.pl -c ../unwind-chain.sh -C

testbeta:
	@../test.pl -c ../unwind-chain.sh -T

testimpr:
	@../test.pl -c ../unwind-chain.sh -K

testnew:
	@../test.pl -c ../unwind-chain.sh -F

test:
	@../test.pl -c ../unwind-chain.sh 

tests.log: ../test.pl
	@../test.pl -c ../unwind-chain.sh 

clean:
	@for dir in *; do \
                if [ -d "$$dir" ]; then \
                        rm $$dir/*.txt $$dir/*.dot $$dir/*.gb $$dir/*.out; \
                fi; \
        done;

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== src/cbmc/Makefile ===
--- 
+++ 
@@ -1,9 +1,10 @@
 SRC = cbmc_main.cpp cbmc_parse_options.cpp bmc.cpp cbmc_dimacs.cpp \
       cbmc_languages.cpp counterexample_beautification.cpp \
       bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
-      xml_interface.cpp cover.cpp all_properties.cpp
+      xml_interface.cpp bmc_cover.cpp all_properties.cpp
 
 OBJ += ../ansi-c/ansi-c$(LIBEXT) \
+      ../cpp/cpp$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
       ../big-int/big-int$(LIBEXT) \
       ../goto-programs/goto-programs$(LIBEXT) \
@@ -19,6 +20,7 @@
       ../pointer-analysis/goto_program_dereference$(OBJEXT) \
       ../goto-instrument/full_slicer$(OBJEXT) \
       ../goto-instrument/nondet_static$(OBJEXT) \
+      ../goto-instrument/cover$(OBJEXT) \
       ../analyses/analyses$(LIBEXT) \
       ../langapi/langapi$(LIBEXT) \
       ../xmllang/xmllang$(LIBEXT) \
@@ -42,17 +44,17 @@
   CP_CXXFLAGS += -DHAVE_BV_REFINEMENT
 endif
 
-ifneq ($(wildcard ../cpp/Makefile),)
-  OBJ += ../cpp/cpp$(LIBEXT)
-  CP_CXXFLAGS += -DHAVE_CPP
-endif
-
 ifneq ($(wildcard ../java_bytecode/Makefile),)
   OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
   CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
-  ifneq ($(LIBZIPLIB),)
-    LIBS += -L $(LIBZIPLIB) -lzip -lz
+  ifneq ($(wildcard $(LIBZIPINC)),)
+    LIBS += $(LIBZIPLIB)
   endif
+endif
+
+ifneq ($(wildcard ../jsil/Makefile),)
+  OBJ += ../jsil/jsil$(LIBEXT)
+  CP_CXXFLAGS += -DHAVE_JSIL
 endif
 
 ifneq ($(wildcard ../specc/Makefile),)

=== src/cegis/Makefile ===
--- 
+++ 
@@ -19,28 +19,47 @@
       safety/value/individual_to_safety_solution_deserialiser.cpp \
       invariant/options/invariant_program.cpp invariant/options/target_copy_helper.cpp \
       invariant/util/copy_instructions.cpp invariant/util/invariant_program_helper.cpp \
-      invariant/util/invariant_constraint_variables.cpp invariant/instrument/meta_variables.cpp \
+      invariant/util/invariant_constraint_variables.cpp \
       invariant/constant/add_constant.cpp invariant/constant/default_constant_strategy.cpp \
       invariant/constant/literals_constant_strategy.cpp invariant/meta/meta_variable_names.cpp \
       invariant/preprocess/add_invariants_and_temp_variables.cpp invariant/preprocess/remove_loops_and_assertion.cpp \
       invariant/symex/learn/add_counterexamples.cpp invariant/symex/learn/add_invariant_programs_to_learn.cpp \
-      invariant/symex/learn/instrument_vars.cpp invariant/symex/learn/invariant_library.cpp \
+      invariant/symex/learn/instrument_vars.cpp \
       invariant/symex/learn/replace_operators.cpp invariant/symex/verify/extract_counterexample.cpp \
       invariant/symex/verify/insert_constraint.cpp invariant/symex/verify/insert_program.cpp \
       invariant/fitness/concrete_fitness_source_provider.cpp \
-      wordsize/restrict_bv_size.cpp value/program_individual_serialisation.cpp \
-      seed/literals_seed.cpp genetic/tournament_select.cpp genetic/match_select.cpp \
+      jsa/facade/jsa_runner.cpp jsa/options/jsa_program.cpp jsa/options/jsa_program_info.cpp \
+      jsa/preprocessing/jsa_preprocessing.cpp jsa/preprocessing/remove_loop.cpp \
+      jsa/preprocessing/add_constraint_meta_variables.cpp jsa/preprocessing/inline_user_program.cpp \
+      jsa/preprocessing/default_jsa_constant_strategy.cpp jsa/preprocessing/create_temp_variables.cpp \
+      jsa/preprocessing/collect_variables.cpp jsa/preprocessing/clone_heap.cpp \
+      jsa/preprocessing/add_synthesis_library.cpp \
+      jsa/learn/jsa_symex_learn.cpp jsa/learn/insert_counterexample.cpp jsa/learn/insert_predicates_and_queries.cpp \
+      jsa/learn/instrument_pred_ops.cpp jsa/learn/execute_jsa_programs.cpp jsa/learn/extract_candidate.cpp \
+      jsa/verify/jsa_symex_verify.cpp jsa/verify/extract_counterexample.cpp jsa/verify/renondet_inputs.cpp \
+      jsa/verify/insert_solution.cpp \
+      jsa/constraint/jsa_constraint_factory.cpp \
+      jsa/converters/solution.cpp jsa/converters/translate_to_goto_program.cpp jsa/converters/replace_operators.cpp \
+      jsa/converters/counterexample.cpp \
+      jsa/instrument/jsa_meta_data.cpp \
+      jsa/value/jsa_solution.cpp jsa/value/jsa_solution_printer.cpp jsa/value/jsa_types.cpp jsa/value/jsa_counterexample_printer.cpp \
+      jsa/genetic/jsa_source_provider.cpp jsa/genetic/dynamic_jsa_test_runner.cpp jsa/genetic/random_jsa_mutate.cpp \
+      jsa/genetic/random_jsa_cross.cpp jsa/genetic/jsa_genetic_convert.cpp jsa/genetic/jsa_random.cpp \
+      jsa/genetic/solution_helper.cpp jsa/genetic/jsa_serialiser.cpp jsa/genetic/jsa_paragon_wrapper.cpp \
+      wordsize/restrict_bv_size.cpp value/program_individual_serialisation.cpp value/assignments_printer.cpp \
+      seed/literals_seed.cpp \
       genetic/instruction_set_info_factory.cpp genetic/random_mutate.cpp genetic/random_cross.cpp \
       genetic/random_individual.cpp genetic/genetic_constant_strategy.cpp instructions/instruction_set_factory.cpp \
-      genetic/concrete_test_runner.cpp genetic/dynamic_test_runner_helper.cpp genetic/genetic_settings.cpp \
-      cegis-util/task_pool.cpp cegis-util/constant_width.cpp cegis-util/irep_pipe.cpp \
-      runner/cegis_parse_options.cpp runner/cegis_main.cpp \
-      ../goto-instrument/dump_c.cpp ../goto-instrument/goto_program2code.cpp \
-      ../cbmc/cbmc_parse_options.cpp ../cbmc/bmc.cpp ../cbmc/cbmc_solvers.cpp ../cbmc/symex_bmc.cpp \
-      ../cbmc/xml_interface.cpp ../cbmc/cover.cpp ../cbmc/bv_cbmc.cpp ../cbmc/counterexample_beautification.cpp \
-      ../cbmc/cbmc_languages.cpp ../cbmc/show_vcc.cpp ../cbmc/cbmc_dimacs.cpp ../cbmc/all_properties.cpp
-
+      genetic/dynamic_test_runner_helper.cpp genetic/genetic_settings.cpp \
+      genetic/serialise_individual.cpp genetic/program_individual_test_runner_helper.cpp \
+      cegis-util/task_pool.cpp cegis-util/constant_width.cpp cegis-util/irep_pipe.cpp cegis-util/program_helper.cpp \
+      cegis-util/temporary_output_block.cpp cegis-util/cbmc_runner.cpp cegis-util/module_helper.cpp \
+      constant/add_constant.cpp constant/literals_collector.cpp constant/default_cegis_constant_strategy.cpp \
+      instrument/cegis_library.cpp instrument/instrument_var_ops.cpp instrument/meta_variables.cpp \
+      runner/cegis_parse_options.cpp runner/cegis_main.cpp
+ 
 OBJ += ../ansi-c/ansi-c$(LIBEXT) \
+      ../jsil/jsil$(LIBEXT) \
       ../cpp/cpp$(LIBEXT) \
       ../java_bytecode/java_bytecode$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
@@ -62,9 +81,20 @@
       ../xmllang/xmllang$(LIBEXT) \
       ../assembler/assembler$(LIBEXT) \
       ../solvers/solvers$(LIBEXT) \
-      ../util/util$(LIBEXT)
+      ../util/util$(LIBEXT) \
+      ../goto-instrument/dump_c$(OBJEXT) ../goto-instrument/goto_program2code$(OBJEXT) \
+      ../goto-instrument/nondet_static$(OBJEXT) ../goto-instrument/cover$(OBJEXT) \
+      ../cbmc/cbmc_parse_options$(OBJEXT) ../cbmc/bmc$(OBJEXT) ../cbmc/cbmc_solvers$(OBJEXT) \
+      ../cbmc/symex_bmc$(OBJEXT) ../cbmc/xml_interface$(OBJEXT) ../cbmc/bmc_cover$(OBJEXT) \
+      ../cbmc/bv_cbmc$(OBJEXT) ../cbmc/counterexample_beautification$(OBJEXT) \
+      ../cbmc/cbmc_languages$(OBJEXT) ../cbmc/show_vcc$(OBJEXT) \
+      ../cbmc/cbmc_dimacs$(OBJEXT) ../cbmc/all_properties$(OBJEXT)
 
 INCLUDES= -I ..
+
+ifeq ($(filter-out Unix MinGW Cygwin OSX OSX_Universal FreeBSD,$(BUILD_ENV_)),)
+  DLFCN_LINKFLAGS = -ldl
+endif
 
 LIBS = $(DLFCN_LINKFLAGS)
 
@@ -75,6 +105,14 @@
 
 all: cegis$(EXEEXT)
 
+ifneq ($(wildcard ../java_bytecode/Makefile),)
+  OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
+  CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
+  ifneq ($(wildcard $(LIBZIPINC)),)
+    LIBS += $(LIBZIPLIB)
+  endif
+endif
+
 ###############################################################################
 
 cegis$(EXEEXT): $(OBJ)

=== src/java_bytecode/Makefile ===
SRC = java_bytecode_language.cpp java_bytecode_parse_tree.cpp \
      java_bytecode_typecheck.cpp expr2java.cpp \
      java_bytecode_convert_class.cpp java_types.cpp java_entry_point.cpp \
      java_bytecode_typecheck_code.cpp java_bytecode_typecheck_expr.cpp \
      java_bytecode_typecheck_type.cpp java_bytecode_internal_additions.cpp \
      java_class_identifier.cpp java_bytecode_parser.cpp bytecode_info.cpp \
      java_class_loader.cpp jar_file.cpp java_object_factory.cpp \
      java_bytecode_convert_method.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = java_bytecode$(LIBEXT)

ifneq ($(wildcard $(LIBZIPINC)),)
  INCLUDES += -I $(LIBZIPINC)
  CP_CXXFLAGS += -DHAVE_LIBZIP
endif

all: java_bytecode$(LIBEXT)

###############################################################################

java_bytecode$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/util/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
       mp_arith.cpp namespace.cpp parse_options.cpp rename.cpp \
       replace_expr.cpp threeval.cpp typecheck.cpp graph.cpp \
       type.cpp cnf_simplify.cpp pointer_predicates.cpp merge_irep.cpp \
-      parser.cpp replace_symbol.cpp json.cpp \
+      parser.cpp replace_symbol.cpp json.cpp get_base_name.cpp \
       simplify_expr.cpp simplify_expr_floatbv.cpp simplify_expr_int.cpp \
       simplify_expr_array.cpp simplify_expr_struct.cpp \
       simplify_expr_boolean.cpp simplify_expr_pointer.cpp \
@@ -21,7 +21,7 @@
       bv_arithmetic.cpp tempdir.cpp tempfile.cpp timer.cpp unicode.cpp \
       irep_ids.cpp byte_operators.cpp string2int.cpp file_util.cpp \
       memory_info.cpp pipe_stream.cpp irep_hash.cpp endianness_map.cpp \
-      vtable.cpp ssa_expr.cpp
+      ssa_expr.cpp json_expr.cpp
 
 INCLUDES= -I ..

=== debian/changelog ===
cbmc (5.5-1) unstable; urgency=low

  * New upstream release

 -- Michael Tautschnig <mt@debian.org>  Sun, 16 Oct 2016 13:10:20 +0100

## cbmc 5.6

=== regression/Makefile ===
DIRS = ansi-c cbmc cpp goto-instrument

test:
	$(foreach var,$(DIRS), $(MAKE) -C $(var) test || exit 1;)

=== src/Makefile ===
--- 
+++ 
@@ -93,7 +93,9 @@
 
 libzip-download:
 	@echo "Downloading libzip 1.1.2"
-	@lwp-download http://www.nih.at/libzip/libzip-1.1.2.tar.gz
+	# The below wants SSL
+	#@lwp-download http://www.nih.at/libzip/libzip-1.1.2.tar.gz
+	@lwp-download http://http.debian.net/debian/pool/main/libz/libzip/libzip_1.1.2.orig.tar.gz
 	@tar xfz libzip-1.1.2.tar.gz
 	@rm -Rf ../libzip
 	@mv libzip-1.1.2 ../libzip

=== unit/Makefile ===
SRC = cpp_parser.cpp cpp_scanner.cpp elf_reader.cpp float_utils.cpp \
      ieee_float.cpp json.cpp miniBDD.cpp osx_fat_reader.cpp \
      smt2_parser.cpp wp.cpp

INCLUDES= -I ../src/

include ../src/config.inc
include ../src/common

LIBS = ../src/ansi-c/ansi-c$(LIBEXT) \
       ../src/cpp/cpp$(LIBEXT) \
       ../src/json/json$(LIBEXT) \
       ../src/linking/linking$(LIBEXT) \
       ../src/util/util$(LIBEXT) \
       ../src/big-int/big-int$(LIBEXT) \
       ../src/goto-programs/goto-programs$(LIBEXT) \
       ../src/pointer-analysis/pointer-analysis$(LIBEXT) \
       ../src/langapi/langapi$(LIBEXT) \
       ../src/assembler/assembler$(LIBEXT) \
       ../src/analyses/analyses$(LIBEXT) \
       ../src/solvers/solvers$(LIBEXT) \

CLEANFILES = $(SRC:.cpp=$(EXEEXT))

all: $(SRC:.cpp=$(EXEEXT))

###############################################################################

cpp_parser$(EXEEXT): cpp_parser$(OBJEXT)
	$(LINKBIN)

cpp_scanner$(EXEEXT): cpp_scanner$(OBJEXT)
	$(LINKBIN)

elf_reader$(EXEEXT): elf_reader$(OBJEXT)
	$(LINKBIN)

float_utils$(EXEEXT): float_utils$(OBJEXT)
	$(LINKBIN)

ieee_float$(EXEEXT): ieee_float$(OBJEXT)
	$(LINKBIN)

json$(EXEEXT): json$(OBJEXT)
	$(LINKBIN)

miniBDD$(EXEEXT): miniBDD$(OBJEXT)
	$(LINKBIN)

osx_fat_reader$(EXEEXT): osx_fat_reader$(OBJEXT)
	$(LINKBIN)

smt2_parser$(EXEEXT): smt2_parser$(OBJEXT)
	$(LINKBIN)

wp$(EXEEXT): wp$(OBJEXT)
	$(LINKBIN)

=== regression/ansi-c/Makefile ===
default: tests.log

test:
	@if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		../failed-tests-printer.pl ; \
		exit 1 ; \
	fi

tests.log: ../test.pl
	@if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		../failed-tests-printer.pl ; \
		exit 1 ; \
	fi

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/array-refinement-with-incr/Makefile ===
default: tests.log

TOOL = "../../../src/cbmc/cbmc --incremental"

test:
	@../test.pl -c $(TOOL)

tests.log: ../test.pl
	@../test.pl -c $(TOOL)

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/cbmc-concurrency/Makefile ===
default: tests.log

test:
	@../test.pl -c ../../../src/cbmc/cbmc

tests.log: ../test.pl
	@../test.pl -c ../../../src/cbmc/cbmc

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/cbmc-cover/Makefile ===
default: tests.log

test:
	@if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		../failed-tests-printer.pl ; \
		exit 1 ; \
	fi

tests.log: ../test.pl
	@if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		../failed-tests-printer.pl ; \
		exit 1 ; \
	fi

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/cbmc-with-incr/Makefile ===
default: tests.log

test:
	@../test.pl -c "../../../src/cbmc/cbmc --incremental"

tests.log: ../test.pl
	@../test.pl -c "../../../src/cbmc/cbmc --incremental"

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

clean:
	@rm -f *.log
	@for dir in *; do rm -f $$dir/*.out; done;

=== regression/goto-analyzer/Makefile ===
default: tests.log

test:
	@../test.pl -c ../../../src/goto-analyzer/goto-analyzer

tests.log: ../test.pl
	@../test.pl -c ../../../src/goto-analyzer/goto-analyzer

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.java" "$$dir/*.out"; \
		fi; \
	done;

=== regression/goto-instrument/Makefile ===

default: tests.log

test:
	@if ! ../test.pl -c ../chain.sh ; then \
		../failed-tests-printer.pl ; \
		exit 1; \
	fi

tests.log:
	@if ! ../test.pl -c ../chain.sh ; then \
		../failed-tests-printer.pl ; \
		exit 1; \
	fi

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

clean:
	@for dir in *; do \
		rm -f tests.log; \
		if [ -d "$$dir" ]; then \
			cd "$$dir"; \
			rm -f *.out *.gb; \
			cd ..; \
		fi \
	done

=== regression/k-induction/Makefile ===
default: tests.log

test:
	@../test.pl -c ../chain.sh

tests.log: ../test.pl
	@../test.pl -c ../chain.sh

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/strings/Makefile ===

test:
	../test.pl -c ../../../src/cbmc/cbmc

=== debian/changelog ===
cbmc (5.6-1) unstable; urgency=low

  * New upstream release
  * Disable Pointer_array5 test due to endianness bugs (Closes: #844776)

 -- Michael Tautschnig <mt@debian.org>  Sun, 04 Dec 2016 09:18:48 +0000

=== debian/control ===
Source: cbmc
Section: science
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 9), minisat (>= 1:2.2.1-2), zlib1g-dev,
 flex, bison, libzip-dev
Standards-Version: 3.9.8
Homepage: http://www.cprover.org/cbmc/

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 		MINISAT2=/usr/include/minisat \
 		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
 		LIBZIPINC=/usr \
-		LIBZIPLIB=/usr/lib
+		LIBZIPLIB="-lzip -lminisat"
 
 override_dh_auto_test:
 	cd regression/ansi-c ; \
@@ -49,10 +49,3 @@
 			exit 1 ; \
 		fi
 
-DEB_VERS=5.4
-get-orig-source:
-	svn export http://svn.cprover.org/svn/cbmc/releases/cbmc-$(DEB_VERS)
-	tar cf cbmc_$(DEB_VERS).orig.tar cbmc-$(DEB_VERS)
-	rm -rf cbmc-$(DEB_VERS)
-	gzip -9n cbmc_$(DEB_VERS).orig.tar
-
